/*****************************************************************************/
/*        󥸥⥸塼                                                                                                                        */
/*****************************************************************************/
var ImSearchEngineList = null;

function init() {
	// ؿ
	Procedure.define("ImSearchEngine", new ImSearchEngine());
	// 󥸥ɤ߹
	_getEngineList();
}

function ImSearchEngine() {
	this.getEngineList = _getEngineList;
	this.getYSPSearchResult = _getYSPSearchResult;
	this.getYSPQueryString = _getYSPQueryString;
	this.getSponsoredSearchResult = _getSponsoredSearchResult;
}

function _getEngineList() {
	if( !isNull(ImSearchEngineList) ) {
		return ImSearchEngineList;
	}
	
	// EngineList
	ImSearchEngineList = new Array();
	
	// ¾XMLɤ߹
	var file = new VirtualFile("system/search/search_engine.xml");
	if( file.isFile() ) {
		var xml = new XML( file.read() );
		
		var engine = xml.Engine;
		var length = engine.length();
		for(var i = 0; i < length; i++) {
			obj = new Object();
			obj.id = engine[i].id.text().toXMLString();
			obj.src = engine[i].Image.text().toXMLString();
			obj.title = engine[i].ShortName.text().toXMLString();
			obj.inputEncoding = engine[i].InputEncoding.text().toXMLString();
			obj.url = engine[i].Url.@template.toXMLString();
			obj.type = engine[i].Url.@type.toXMLString();
			
			ImSearchEngineList.push( obj );
		}
	}
	return ImSearchEngineList;
}

function _getYSPQueryString(keyword) {
	// ѥ᡼
	var query = Packages.jp.co.intra_mart.system.common.parts.search_bar.YSPSearchKeys.getQueryParameters();
	
	// ɤURL󥳡ǥ
	var encKey = URL.encode( keyword, "utf-8" );
	encKey = encKey.replace("@", "%40", "g");
	encKey = encKey.replace("*", "%2a", "g");
	
	query += "&" + Packages.jp.co.intra_mart.system.common.parts.search_bar.YSPSearchKeys.QUERY_KEY + "=" + encKey;
	return query;
}

function _getYSPSearchResult(keyword, queryStr) {
	// YSP URL
	var url = Packages.jp.co.intra_mart.system.common.parts.search_bar.YSPSearchKeys.YSP_URL;
	
	if( isBlank(queryStr) ) {
		// 
		queryStr =  _getYSPQueryString(keyword);
	}
	try {
		// YSP 䤤碌
		var args = [url + "?" + queryStr, "utf-8"];
		var result = Packages.jp.co.intra_mart.system.javascript.tools.shell.Global.readUrl(null, null, args, null);
		return result;
	} catch (e) {
		Packages.jp.co.intra_mart.system.Report.error.write(e.message, e.rhinoException);
	}
}

function _getSponsoredSearchResult(keyword, nextArgs) {
	// SponsoredSearch URL
	var url = Packages.jp.co.intra_mart.system.common.parts.search_bar.SSearchKeys.getURL();
	
	// 饤IPɥ쥹
	var clientIP = Web.getRemoteAddr();
	// եȥ(Web֥饦)
	var request = Web.getRequest();
	var userAgent = request.getHeader("User-Agent");
	// 饤ȥץ롼ƥ󥰥롼
	var xfip = request.getHeader("x-fowarded-for");
	
	// 桼
	var affilData = "ip=" + clientIP + "&ua=" + userAgent;
	if( !isBlank(xfip) ) {
		affilData += "&xfip=" + xfip;
	}
	
	// 
	var query = new Array();
	// ѥ᡼
	query[0] = Packages.jp.co.intra_mart.system.common.parts.search_bar.SSearchKeys.getQueryParameters();
	// 桼
	query[1] = Packages.jp.co.intra_mart.system.common.parts.search_bar.SSearchKeys.AFFILIATE_DATA_KEY + "=" + URL.encode(affilData, "utf-8");
	// 
	if( isBlank(nextArgs) ) {
		var encKey = URL.encode(keyword, "utf-8");
		encKey = encKey.replace("@", "%40", "g");
		encKey = encKey.replace("*", "%2a", "g");
		query[2] = Packages.jp.co.intra_mart.system.common.parts.search_bar.SSearchKeys.QUERY_KEY + "=" + encKey;
	} else {
		query[2] = nextArgs;
	}
	
	try {
		var args = [url + "?" + query.join("&"), "utf-8"];
		var result = Packages.jp.co.intra_mart.system.javascript.tools.shell.Global.readUrl(null, null, args, null);
		return result;
	} catch (e) {
		Packages.jp.co.intra_mart.system.Report.error.write(e.message, e.rhinoException);
	}
}
